--| TEST_ESPEC
--|-----------------------------------------------------------------------------
--|   Copyright (C) GunnarGotshalks --  All rights reserved.
--|
--| Permission to use, copy, modify, and distribute,without fee this software
--| and its documentation for educational purpose is hereby granted.
--|-----------------------------------------------------------------------------

note
  description: "Test cases for eSpec"
  author: "Gunnar Gotshalks"
  date: "2006 August 29"
  version: "2.0"

class TEST_ESPEC
  inherit ES_TEST

create make

feature -- Creation

make
  -- Defines the test cases to use
  do
    add_boolean_case (agent test_boolean)
    add_violation_case(agent test_precondition)
    add_boolean_case(agent test_precondition_bool)
-- The following case succeeds only if the pre-condition
-- fails and it has the tag "non-negative".  The test fails.
-- Change the tag to "valid_bounds" and the test succeeds.
--
  add_violation_case_with_tag("non_negative", agent test_precondition)
  end

test_boolean : BOOLEAN
  do
    comment("test_boolean case")
    Result := true
  end

test_precondition
  local array : ARRAY[STRING]
  do
    comment("test_violation")
    create array.make_filled("", 5, 1)
  end

test_precondition_bool : BOOLEAN
  local array : ARRAY[STRING]
  do
    comment("test_violation boolean version")
    if not Result then create array.make_filled("", 5, 1) end
    rescue
      Result := true
      retry
  end

end
